#define PI = 3.14159
#define G = 9.81 

struct beam_data {
	double E;
	double M;
	double I;
	double L;
	int slices;
};

struct ride_data {
	double R;
	double V;
	double theta;
};

compute(struct beam_data bd, struct ride_data rd, double *D ) {
	int i,j;
	double E;
	double I;
	double L;
	double M;
	double R;
	int slices;
	double x;
	double dx;
	double factor;
	double force;
	double coeff;
	double theta;
	double R;
	double V;
	double d;
	
	L = bd.L;
	E = bd.E;
	I = bd.I;
	slices = bd.slices;
	V = rd.V;
	R = rd.R;
	theta = theta.R;

	factor = -1.0;
	if(PI < theta && theta < 2.0 * PI) factor = 1.0; 

	force = M*( (V*V/R) + (factor *G*cos(theta)));

	coeff = -1.0 * force / (48.0 * E * I);

	x = 0.0;
	dx = L / (double) slices;


	for(i = 0; i < slices/2; i++) {
		d = 3.0 * L * L;
		d -= 4.0 * x*x;
		d *= coeff *x;
		*(D + i) = d;	
		*(D + slices - i) = d;
		x += dx;
	}


}
