#include<malloc.h>
#include<stdlib.h>

struct constants {
	float E;
	float I;
	float L;	
};

struct variations {
	float l;
	float p;
};

static float xval[132];
static float disp[132];

void solve_system(float *, float *, struct constants, struct variations);

int *descriptor;

int main(int argc, char** argv) {
	int port;
	int i;
	int number;
	int connection;
	int my_socket;

	float px,py;
	float E;
	float I;
	float L;
	float l;
	float p;

	struct constants C;
	struct variations V;


/*****************************************************************/
        /* Check command lines */
        if(argc != 5) {
                printf("Usage: my_server -p # -n #\n");
                printf("        where -p # is port number\n");
                printf("        where -n # is number of clients\n");
                exit(0);
        }

        for( i = 0; i < 5; i++) {
                if( !strcmp(*(argv + i), "-p")) {
                        port = (int) atoi( *(argv+i+1));
                }
                if( !strcmp(*(argv + i), "-n")) {
                        number = (int) atoi( *(argv+i+1));
                }
        }
        printf("You have requested that I, server, open on port %d\n", port);

        /* Make the socket */
        my_socket = create_socket(port, number);
        if(my_socket == 0) {
                printf("failed to make a socket\n");
                exit(0);
        }

        descriptor = (int *) malloc(number * sizeof(int));

        /* Wait for connections */
        for(i = 0; i < number; i++) {
                *(descriptor+i) = accept_calls(my_socket);
                if(descriptor < 0) {
                        printf("failed to accept\n");
                        exit(0);
                }
        }

        printf("I have accepted a connection\n");
/*****************************************************************/



/*********** Read data from LabView  *******************/

	read(*(descriptor+0), (char*) &E, 1 * sizeof(float));
	read(*(descriptor+0), (char*) &I, 1 * sizeof(float));
	read(*(descriptor+0), (char*) &L, 1 * sizeof(float));

/*********** Fill Constants Structure  *******************/
	C.E = E;
	C.I = I;
	C.L = L;

/*********** Read beam data from Inventor  *******************/
	read(*(descriptor+1), (char*) &xval[0], 132 * sizeof(float));

	connection = 1;

/*********** Enter computational loop *******************/
	while(connection){

/*********** Continually read data from LabView  *******************/

		read(*(descriptor + 0), (char*) &l, 1 * sizeof(float));
		read(*(descriptor + 0), (char*) &p, 1 * sizeof(float));
		read(*(descriptor + 0), (char*) &connection, 1 * sizeof(int));

		printf("read position = %f, and load = %f\n", l,p);

		V.l = l;
		V.p = p;

/*********** Call physics funtion  *******************/

		solve_system(&xval[0], &disp[0], C, V);

/*********** Continually write data to Inventor  *******************/
	
		write(*(descriptor+1), (char*) &l, 1 * sizeof(float));
		write(*(descriptor+1), (char*) &p, 1 * sizeof(float));
		write(*(descriptor+1), (char*) &disp[0], 132 * sizeof(float));
	}
}


void solve_system(float* x, float *y, struct constants C, struct variations V){
	int i, n;

	float X, Y;
	float E, I, L, p, l;
	float coeff;
	float dirac, diff;
	float paren;

	n = 132;


	E = C.E;
	I = C.I;
	L = C.L;
	p = V.p;
	l = V.l;
	coeff = p/(6*E*I);
	coeff *= -1.0;	

	for(i = 0; i < n; i++) {
		X = *(x+ i);
		diff = X-l;
		if(diff <= 0.0) {
			dirac = 0.0;
		} else {
			dirac = 3*diff;
		}	
		paren = dirac;
		paren -= (X*X*X/6.0);
		paren += (X*X*L/2.0);
		Y = coeff * paren;
		*(y + i) = Y;

	}
} 
