#include <stdio.h>
#include <errno.h>
#include <netdb.h>
#include <string.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>

int make_connection(char *server, int port) {
	int socketfd;
	struct hostent *he;
	struct sockaddr_in server_address;

	if (!server || !port) return NULL;

	if ((he=gethostbyname(server)) == NULL) {	// get the host info 
		perror("gethostbyname");
		return -1 * errno;
	}

	if ((socketfd = socket(AF_INET, SOCK_STREAM, 0)) == -1) {
		perror("socket");
		return -1 * errno;
	}

	server_address.sin_family = AF_INET;			// host byte order 
	server_address.sin_port = htons(port);			// short, network byte order 
	server_address.sin_addr = *((struct in_addr *) he->h_addr);
	if (!memset(&(server_address.sin_zero), '\0', 8)) {	// zero the rest of the struct 
		perror("memset");
		return -1 * errno;
	}

	if (connect(socketfd, (struct sockaddr *) &server_address, sizeof(struct sockaddr)) == -1) {
		perror("connect");
		return -1 * errno;
	}

	return socketfd;
}
